---
layout: docs
title: Modules
permalink: /docs/quick-start/modules/
---

# Modules

 Bow is split in multiple modules that can be imported independently. These modules are:

 | Module | Description | Swift import |
 | ------ | ----------- | ------------ |
 | Core | Higher Kinded Types emulation, function manipulation utilities, type classes, data types, monad transformers and instances for primitive types. | `import Bow` |
 | Optics | Immutable data structures manipulation. | `import BowOptics` |
 | Recursion Schemes | Recursive data structures, F-algebras and folding / unfolding functions. | `import BowRecursionSchemes` |
 | Free | Free monads. | `import BowFree` |
 | Generic | Data types for generic programming. | `import BowGeneric` |
 | Effects | Encapsulation of side effects. | `import BowEffects` |
 | Result | Integration with the Result library. | `import BowResult` |
 | BrightFutures | Integration with the BrightFutures library. | `import BowBrightFutures` |
 | RxSwift | Integration with the RxSwift library. | `import BowRx` |
